{% extends "base.html" %}
{% import 'bootstrap/wtf.html' as wtf %}

{% block head %}
    {{ super() }}
    <meta name="referrer" content="never">
{% endblock %}

{% macro render_star_rating_by_label(label, big) %}
    <label class="{{ 'control-label' if big }}">
        {{ form[label].label.text }}
        {% for error in form[label].errors %}
            <b><font color="#a94442">{{ error }}</font></b>
        {% endfor %}
        <small style="font-weight: normal;">
            {{ form[label].description_2|safe }}<br>
            {{ form[label].description_1 }}
        </small>
    </label>
    <input id="{{ label }}" type="text" name="{{ label }}" class="rating rating-loading" data-min="0" data-max="{{ form[label].max_ }}" data-stars="{{ form[label].max_ }}" data-step="1" data-size="xs" data-show-clear="false">
{% endmacro %}

{% macro render_sortable_list(list, other, big) %}
    <div class="sortable-list">
        <label class="{{ 'control-label' if big }}">
            {{ list.title_ }}
            {% for error in list.errors %}
                <b><font color="#a94442">{{ error }}</font></b>
            {% endfor %}
            <br>
            <small>{{ list.description_|safe }}</small>
        </label>

        <ul class="uppercase-list">
            {% for id, description in list.items_ %}
                <li>
                    <input type="checkbox" class="inline-checkbox" name="{{ id }}">
                    {{ id }}. {{ description }}
                </li>
            {% endfor %}
            <li>
                <div>
                    <input type="checkbox" class="inline-checkbox" name="{{ list.other_id }}">
                    {{ list.other_id }}. 其他:&nbsp;
                    {{ other(class="form-control") }}
                </div>
            </li>
        </ul>
        <div style="height: 7px;">
            {{ wtf.form_field(list, class="sortable-list-result", type="hidden") }}
        </div>
    </div>
{% endmacro %}

{% block app_content %}
    <div class="page-header">
        <h1>
            {{ title }}
            <small>请按照以下详细说明认真完成标注</small>
        </h1>
        <div class="btn-toolbar" role="toolbar">
            {% for i, (query, clicked_images) in queries %}
                <a href="{{ query.url }}" class="btn btn-info" target="_blank" role="button">{{ query.keyword }}</a>
            {% endfor %}
        </div><br>
    </div>

    <form class="form" method="post" role="form">
        {{ form.hidden_tag() }}
        <div class="col-md-8" role="main">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>任务层面标注</b></h3>
                </div>
                <ul class="list-group">
                    <li class="list-group-item">{{ wtf.form_field(form.task_intention) }}</li>
                    <li class="list-group-item">{{ render_sortable_list(form.task_evaluation_standard, form.task_evaluation_standard_other, true) }}</li>
                    <li class="list-group-item">{{ render_star_rating_by_label('task_satisfaction', true) }}</li>
                </ul>
            </div>

            {% for i, (query, clicked_images) in queries %}
                <div class="panel panel-colorful">
                    <div class="panel-heading">
                        <h3 class="panel-title">查询词层面标注: <b>{{ query.keyword }}</b></h3>
                    </div>
                    <ul class="list-group">
                        <li class="list-group-item">
                            {{ render_star_rating_by_label('query_%d_satisfaction'%i, true) }}
                        </li>
                        {% for j, clicked_image in clicked_images %}
                            <li class="list-group-item">
                                <div class="media">
                                    <div class="media-left">
                                        <a href="{{ clicked_image.url }}" target="_blank">
                                            <img class="img-rounded" src="{{ clicked_image.url }}" alt="">
                                        </a>
                                    </div>
                                    <div class="media-body">
                                        {{ render_star_rating_by_label('clicked_image_%d_%d_relevance'%(i,j), false) }}
                                        {{ render_star_rating_by_label('clicked_image_%d_%d_usefulness'%(i,j), false) }}
                                    </div>
                                    {{ render_sortable_list(form['clicked_image_%d_%d_click_standard'%(i,j)], form['clicked_image_%d_%d_click_standard_other'%(i,j)], false) }}
                                </div>
                            </li>
                        {% endfor %}
                    </ul>
                </div>
            {% endfor %}
        </div>

        <div class="col-md-4" role="complementary">
            {% include '_feedback_overview.html' %}
            {{ wtf.form_field(form.submit, class="btn btn-success btn-lg", disabled="") }}
            {{ wtf.form_errors(form, hiddens="only") }}
        </div>
    </form>
{% endblock %}

{% block scripts %}
    {{ super() }}
    <link href="{{ url_for('static',filename='css/star-rating.min.css') }}" media="all" rel="stylesheet" type="text/css" />
    <script src="{{ url_for('static',filename='js/star-rating.min.js') }}" type="text/javascript"></script>
    <script src="{{ url_for('static',filename='js/locales/zh.js') }}""></script>

    <style type="text/css">
     img {
         max-width: 250px;
         max-height: 160px;
     }
     .form-group {
         margin-bottom: 5px;
     }
     .list-group {
         min-height: 45px;
     }
     .list-group-item {
         padding-top: 15px;
     }
     .list-group-hover .list-group-item:hover {
         background-color: #f5f5f5;
     }
     .nolabel .control-label {
         display: none;
     }
     .ignore-errors .help-block {
         display: none;
     }
     .btn {
         margin-top: 3px;
     }
     .control-label {
         font-size: 17px;
         margin-bottom: 5px;
     }
     small {
         font-weight: normal;
         color: #737373;
     }
     textarea.form-control {
         height: 130px;
     }
     .uppercase-list {
         list-style: none;
         padding-left: 5px;
         line-height: 1.9;
         columns: 2;
         -webkit-columns: 2;
         -moz-columns: 2;
     }
     .uppercase-list .form-control {
         display: inline-block;
         width: max-content;
         height: 30px;
     }
     .btn-toolbar {
         margin-left: 0px;
         margin-bottom: -15px;
     }
    </style>

    <script type="text/javascript">
     function validate() {
         var valid = true;
         if ($("#task_intention").val().length < 1 || $("#task_intention").val().length > 500)
             valid = false;
         $(".sortable-list-result").each(function (index) {
             if (this.value.length < 2 || this.value.length > 3)
                 valid = false;
         });
         $(".rating-stars input").each(function (index) {
             if (this.value == "")
                 valid = false;
         });
         console.log(valid);
         $("#submit").prop("disabled", !valid);
     };

     $("#task_intention").bind("input propertychange", function () {
         validate();
     });

     $(".rating").rating({language: 'zh'}).on("rating:change", function(event, value, caption) {
         validate();
     });

     $(".sortable-list").each(function (index) {
         var context = this;
         $(".inline-checkbox", context).change(function () {
             var str = "";
             $(".inline-checkbox", context).each(function (id, el) {
                 if (this.checked)
                     str += this.name;
             });
             $(".sortable-list-result", context).val(str);
             validate();
         });
     });

     function randomColor(colorNum, colors){
         return "hsl(" + 360 * Math.random() + ","
              + (25 + 70 * Math.random()) + "%,"
              + (85 + 10 * Math.random()) + "%)";
     }

     $(".panel-colorful").each(function() {
         var hue = randomColor;
         $(this).css("background-color", hue);
     });
    </script>
​{% endblock %}
